Package io.github.jdbcx

# Interface DriverExtension

All Known Implementing Classes:
  `BlackholeDriverExtension`, `DefaultDriverExtension`, `PrqlDriverExtension`, `ScriptDriverExtension`, `ShellDriverExtension`

public interface DriverExtension

## Method Summary

Modifier and Type
Method
Description
`default ConnectionListener`
`createListener(Connection conn, String url, Properties props)`
Creates a connection listener.
`default Properties`
`getConfig(Properties props)`
Gets configuration for this extension.
`default Properties`
`getDefaultConfig()`
Gets default configuration for this extension.
`default List<Option>`
`getDefaultOptions()`
Gets default options for this extension.
`default List<Option>`
`getOptions(Properties props)`
Gets options available for this extension.

## Method Details

### createListener

default ConnectionListener createListener(Connection conn, String url, Properties props)
Creates a connection listener.

Parameters:
  `conn` - connection to listen
  `url` - connection string
  `props` - connection properties
Returns:
  non-null connection listener

### getConfig

default Properties getConfig(Properties props)
Gets configuration for this extension.

Parameters:
  `props` - optional connection properties to merge into the configuration, could be null
Returns:
  non-null configuration for this extension

### getDefaultConfig

default Properties getDefaultConfig()
Gets default configuration for this extension. Same as `getConfig(null)`.

Returns:
  non-null default configuration

### getOptions

default List<Option> getOptions(Properties props)
Gets options available for this extension.

Parameters:
  `props` - optional connection properties, could be null
Returns:
  non-null options for this extension

### getDefaultOptions

default List<Option> getDefaultOptions()
Gets default options for this extension. Same as `getOptions(null)`.

Returns:
  non-null default options